:- use_module(library(lists)).

% mondat(Alany, ll, L0, L): L0-L kielemezhet egy Alany alanybl
% s ll lltmnybl ll mondatt.
% Alany lehet els vagy msodik szemly nvms, vagy egyetlen szbl
% ll (harmadik szemly) alany.
mondat(n, ll) --> perm(n, ll).
mondat(te, ll) --> perm(te, ll).
mondat(Alany, ll) --> sz(Alany), szavak(ll).

% perm(Ki, ll, L0, L): L0-L kielemezhet egy Ki (els vagy msodik szemly) 
% nvmsbl s ll lltmnybl ll mondatt. 
perm(Ki, ll) --> nvms(Ki), ltige(Ki), szavak(ll).
perm(Ki, ll) --> nvms(Ki), szavak(ll), ltige(Ki).
perm(Ki, ll) --> szavak(ll), ltige(Ki), nvms(Ki).
perm(Ki, ll) --> szavak(ll), ltige(Ki).

% nvms(Ki, L0, L): L0-L egy Ki nvms.
nvms(n) --> "n", kz.        nvms(te) --> "te", kz. 
nvms(n) --> "n", kz.        nvms(te) --> "Te", kz. 

% ltige(Ki, L0, L): L0-L egy Ki nvmssal egyeztetett ltige.
ltige(n) --> "vagyok", kz.    ltige(te) --> "vagy", kz. 

% kz(L0, L): L0-L nulla, egy vagy tbb szkz.
kz --> " " -> kz ; [].

% sz(Sz, L0, L): L0-L egy Sz betsorozatbl ll (nem res) sz.
% Betnek szmt minden a ".?" jelektl klnbz karakter.
sz([B|Sz]) --> bet(B), szmaradk(Sz), kz.

% szmaradk(Sz, L0, L): L0-L egy Sz betsorozatbl ll (esetleg res) sz.
szmaradk([B|Sz]) --> bet(B), !, szmaradk(Sz).
szmaradk([]) --> [].

% bet(K, L0, L): L0-L egy K kd bet.
bet(K) --> [K], {non_member(K, " .?")}.

% szavak(SzL, L0, L): L0-L egy SzL sz-lista.
szavak([Sz|Szk]) --> sz(Sz), 
     (   szavak(Szk)
     ;   {Szk = []}
     ).

% menet(Monds, L0, L): Az L0-L kielemzett alakja Monds.
menet(kijelent(Alany,ll)) --> 
    mondat(Alany, ll), ".".
menet(krdez(Alany)) --> 
    mondat(Alany, [Sz]), "?", {krd(Sz)}.
menet(un) --> "Unlak.".

% krd(Sz): Sz egy krdsz.
krd("mi").   krd("ki").   krd("kicsoda").
krd("Mi").   krd("Ki").   krd("Kicsoda").

% Egy prbeszdet valst meg.
prbeszd :-
     repeat, rd_line(L),
     (   menet(M, L, []) -> feldolgoz(M)
     ;   write('Nem rtem\n'), fail
     ), M = un, !.

% feldolgoz(Monds): feldolgozza a felhasznltl rkez Monds zenetet.
feldolgoz(un) :- write('n is.\n').
feldolgoz(kijelent(Alany, ll)) :-
     assertz(tudom(Alany,ll)), write('Felfogtam.\n').
feldolgoz(krdez(Alany)) :-
     tudom(Alany, _), !, vlasz(Alany).
feldolgoz(krdez(_)) :-
     write('Nem tudom.\n').

% Felsorolja az Alany ismert tulajdonsgait.
vlasz(Alany) :- tudom(Alany, ll),
     (   member(Sz, ll), format('~s ', [Sz]), fail
     ;   nl, fail
     ).
vlasz(_).

% -------- Sorbeolvass ---------
% L a kvetkez sor karakterkdjainak listja.
rd_line(L):-
        get_code(C), rd_line(C, L).

% rd_line(C, L): L a kvetkez sor karakterkdjainak
% listja, ha C a soronkvetkez karakter kdja.
rd_line(10, []):- !.
rd_line(C, [C|L]):-
        get_code(C1), rd_line(C1, L).
