% :- type ll --->   lmpa-list(ember). % Hol a lmpa s hol vannak az emberek?
% :- type lmpa ==   oldal.             % A lmpa az egyik oldalon lehet.
% :- type ember ==   list(pair(int,oldal)).  % Minden adott kor ember mellett
                                        % ott a tartzkodsi helye.
% :- type oldal ---> bal ; jobb.

% tszakasz(ll0, ll1, Id): Id alatt az ll0 llapotbl ll1-be lehet jutni.
% :- pred tszakasz(ll::in, ll::out, int::out).
tszakasz(Innen-Helyzet0, Ide-Helyzet, Id) :-
	msik(Innen, Ide),     % A lmpa az Innen oldalon van, Ide a tloldal.
	cserl(E1-Innen, Helyzet0, E1-Ide, Helyzet),       % E1 tmegy
	Id = E1.
tszakasz(Innen-Helyzet0, Ide-Helyzet, Id) :-
	msik(Innen, Ide),
	cserl(E1-Innen, Helyzet0, E1-Ide, Helyzet1),      % E1 tmegy     
	cserl(E2-Innen, Helyzet1, E2-Ide, Helyzet),       % E2 tmegy
	E1 > E2, Id = E1.

% msik(Egyik, Msik): Egyik s Msik kt klnbz oldal.
% :- pred msik(oldal, oldal).
msik(bal, jobb).
msik(jobb, bal).

% cserl(X, XL, Y, YL): egy X elemet XL-ben Y-ra cserlve kapjuk YL-t.
% Deklaratvabban: X ugyanannyiadik eleme XL-nek, mint Y YL-nek, s a kt
% lista csak ebben az elemben klnbzik. 
% :- pred cserl(T, list(T)::in, T, list(T)::out).
% :- pred cserl(T, list(T)::out, T, list(T)::in).
cserl(X, [X|Xlista], Y, [Y|Xlista]).
cserl(X, [Head|Xlista], Y, [Head|Ylista]) :-
	cserl(X, Xlista, Y, Ylista).

% vghelyzet(Hol, ll): Az ll llapotban minden a Hol oldalon van.
% :- pred vghelyzet(oldal, ll).
vghelyzet(Hol, Hol-[10-Hol,20-Hol,50-Hol,100-Hol]).

:- ensure_loaded(between).

% t lehet menni a bal vghelyzetbl a jobb vghelyzetbe
% Hossz Id alatt az t llapotlistn keresztl.
% :- pred tmegy(list(ll)::out, int::out).
tmegy(t, Hossz) :-
	vghelyzet(bal, Kezd),
	vghelyzet(jobb, Vg),
	between(1, 10, N),
	tvonal_4(N, Kezd, Vg, t, Hossz).

:- use_module(library(lists), [member/2, reverse/2]).

% tvonal_4(N, A, B, t, H): A s B kztt van (pontosan)
% N szakaszbl ll krmentes  t tvonal, amelynek sszhossza H.
tvonal_4(N, Honnan, Hov, t, H) :-
        tvonal_4(N, Honnan, Hov,  [Honnan], t, H).

% tvonal_4(N, A, B, K, t, H): A s B kztt van pontosan
% N szakaszbl ll krmentes, K elemein t nem men H hossz  t t.
tvonal_4(0, Hov, Hov,  Kizrtak, t, 0)  :- 
	reverse(Kizrtak, t).
tvonal_4(N, Honnan, Hov, Kizrtak,  t, H) :-
        N > 0, N1 is N-1, 
        tszakasz(Honnan, Kzben, H1),
        \+ member(Kzben, Kizrtak),
        tvonal_4(N1, Kzben, Hov, [Kzben|Kizrtak],  t, H2), 
	H is H1+H2.





