% :- type ll --->   lmpa-list(ember). % Hol a lmpa s hol vannak az emberek?
% :- type lmpa ==   oldal.             % A lmpa az egyik oldalon lehet.
% :- type ember ==   list(pair(int,oldal)).  % Minden adott kor ember mellett
                                        % ott a tartzkodsi helye.
% :- type oldal ---> bal ; jobb.

% :- type lps ---> tmenk>oldal.     % az adott oldalRA tmennek az tmenk.
% :- type tmenk == int \/ {int+int}.  % egy vagy kt adott kor ember.

% tszakasz(ll0, ll1, Id, Lps): A Lps lpssel Id alatt az ll0
% llapotbl az ll1 llapotba lehet jutni.
% :- pred tszakasz(ll::in, ll::out, int::out, lps::out).
tszakasz(Innen-Helyzet0, Ide-Helyzet, Id, E1>Ide) :-     % E1 megy t.
	msik(Innen, Ide),     % A lmpa az Innen oldalon van, Ide a tloldal.
	cserl(E1-Innen, Helyzet0, E1-Ide, Helyzet),       % E1 tmegy
	Id = E1.
tszakasz(Innen-Helyzet0, Ide-Helyzet, Id, E1+E2>Ide) :-  % E1+E2 megy t.
	msik(Innen, Ide),
	cserl(E1-Innen, Helyzet0, E1-Ide, Helyzet1),      % E1 tmegy     
	cserl(E2-Innen, Helyzet1, E2-Ide, Helyzet),       % E2 tmegy
	E1 > E2, Id = E1.

% msik(Egyik, Msik): Egyik s Msik kt klnbz oldal.
% :- pred msik(oldal, oldal).
msik(bal, jobb).
msik(jobb, bal).

% cserl(X, XL, Y, YL): egy X elemet XL-ben Y-ra cserlve kapjuk YL-t.
% Deklaratvabban: X ugyanannyiadik eleme XL-nek, mint Y YL-nek, s a kt
% lista csak ebben az elemben klnbzik. 
% :- pred cserl(T, list(T)::in, T, list(T)::out).
% :- pred cserl(T, list(T)::out, T, list(T)::in).
cserl(X, [X|Xlista], Y, [Y|Xlista]).
cserl(X, [Head|Xlista], Y, [Head|Ylista]) :-
	cserl(X, Xlista, Y, Ylista).

% vghelyzet(Hol, ll): Az ll llapotban minden a Hol oldalon van.
% :- pred vghelyzet(oldal, ll).
vghelyzet(Hol, Hol-[10-Hol,20-Hol,50-Hol,100-Hol]).

% Lpsek-kel t lehet menni a bal vghelyzetbl a jobb vghelyzetbe
% Hossz Id alatt, ahol Hossz < Max.
% :- pred tmegy(int::in, list(lps)::out, int::out).
tmegy(Max, Lpsek, Hossz) :-
	vghelyzet(bal, Kezd),
	vghelyzet(jobb, Vg),
	tvonal_6(Kezd, Vg, Max, Lpsek, Nyeresg),
	Hossz is Max - Nyeresg.

% tvonal_6(A, B, Max, Lk, Nyer): A s B kztt van egy Max-nl 
% Nyer-rel rvidebb t (Nyer > 0), amelynek lpssorozata Lk.
% :- pred tvonal_6(ll::in, ll::in, int::in, list(lps)::out, int::out).
tvonal_6(Hov, Hov, Max, [], Max)  :- 
	Max > 0.
tvonal_6(Honnan, Hov, Max0, [Lp|LpL], Nyer) :-
        Max0 > 0,
	tszakasz(Honnan, Kzben, H1, Lp),
	Max1 is Max0-H1, 
        tvonal_6(Kzben, Hov, Max1, LpL, Nyer).
